//This file is meant to be edited

#include <ESP32Servo.h>  // older version <ESP32_Servo.h>, newer version same library <ESP32Servo.h>
#include "car.h"

namespace car{
  //define the motorLSpeed and motorRSpeed variables as integers (numbers)
  int motorLSpeed;
  int motorRSpeed;

  Servo myservo;

  void setupFunction(){
    // This code runs once at startup
    myservo.attach(16, 500, 2400);
    pinMode(4, OUTPUT);

    pinMode(22, OUTPUT); //Turn on built in led
  }

  void loopFunction(){
    // This code runs repeatedly after startup
    digitalWrite(22, false); //Blink builtin led
    delay(100);
    digitalWrite(22, true);
    delay(1000);

    // can add more to this loop
  }

  void movement(int throttle, int rotation){
    // This code runs when the (virtual) joystick values change
    // Do not use delays here
    
    //calculate the motor speed
    motorLSpeed = throttle - rotation;
    motorRSpeed = throttle + rotation;
  
    //write the motor trottle values
    writeMotorL(motorLSpeed);
    writeMotorR(motorRSpeed);
  }

  void button1(){
    // This code runs when button 1 on the controller is pressed
    myservo.write(0);
    digitalWrite(4, true);
    Serial.println("button 1");
  }

  void button2(){
    // This code runs when button 2 on the controller is pressed
    myservo.write(60);
    Serial.println("button 2");
  }

  void button3(){
    // This code runs when button 3 on the controller is pressed
    myservo.write(120);
    Serial.println("button 3");
  }

  void button4(){
    // This code runs when button 4 on the controller is pressed
    myservo.write(180);
    digitalWrite(4, false);
    Serial.println("button 4");
  }
}
